use clap::Args;
use serde::Deserialize;

#[derive(Args, Debug, Deserialize)]
pub struct AsphyxiaConfig {
    #[clap(
        long,
        default_value = "",
        help = "your sdvx user id generated by asphyxia@sdvx plugin"
    )]
    pub refid: String,

    #[clap(
        long,
        default_value = "savedata.db",
        help = "the path of your game record db file"
    )]
    pub record_path: String,

    #[clap(
        long,
        default_value = "music_db.xml",
        help = "the path of your game music_db.xml file"
    )]
    pub music_path: String,
}

impl Default for AsphyxiaConfig {
    fn default() -> Self {
        Self {
            refid: "".to_string(),
            record_path: "savedata.db".to_string(),
            music_path: "music_db.xml".to_string(),
        }
    }
}
